Testing Unateness of Real-Valued Functions111This work was partially supported by NSF award CCF-1422975.
Abstract
We give a unateness tester for functions of the form , where and with query complexity . Previously known unateness testers work only for Boolean functions over the domain . We show that every unateness tester for real-valued functions over hypergrid has query complexity . Consequently, our tester is nearly optimal for real-valued functions over . We also prove that every nonadaptive, 1-sided error unateness tester for Boolean functions needs queries. Previously, no lower bounds for testing unateness were known.
1 Introduction
We study property testing unateness of functions of the form , where and . Unate functions are used in mathematics and other technical disciplines, for example in tautology checking [14, 15] and in switching theory [17]. For , where and , we define . Two points are neighbours if . A function is unate if each dimension can be assigned an associated direction up or down; the direction is up if for all neighbours where ; and the direction is down if for all such and . Moreover, a function is monotone if the direction is up in all dimensions. Thus, unateness is a generalization of monotonicity.
The domain is called a hypergrid and the special case is called a hypercube. The distance between two functions is equal to the fraction of points where . Given a parameter , two functions and are -far from each other if the distance between and is at least . A function is -far from a property if it is -far from any function which has property . A property tester [10, 16] for a property is a randomized algorithm which, given parameter and oracle access to the input function , accepts with probability , if it has the property , and rejects with probability , if it is -far from . A tester is nonadaptive if it makes all queries in advance, and adaptive otherwise. A testing algorithm for property has -sided error if it always accepts all inputs that satisfy and -sided error, otherwise. A unateness tester is a property tester for unateness. To the best of our knowledge, testing unateness has been studied previously only for Boolean functions over the hypercube domain.
1.1 Our results
In this paper, we give a unateness tester for real-valued function over the hypergrid. It is the first unateness tester for this type of functions. We also present first lower bounds on the number of queries required to test unateness. In particular, our tester and lower bound differ only by a logarithmic factor for real-valued functions over the hypercube.
The query complexity of our unateness tester is for functions . Our tester generalizes the tester of Khot and Shinkar [12] to real-valued functions over the hypergrid domain. Their tester has query complexity and it works for Boolean functions over the hypercube domain.
We also present two lower bounds for testing unateness of functions over the hypercube domain. The first lower bound of , where is the range of the function, is over the real-valued functions. Our second lower bound of is for nonadaptive, 1-sided error unateness testers over Boolean functions. Our lower bounds build on the same lower bounds for monotonicity testing by Blais et al. [3] and Fischer et al. [9] of Boolean functions over the hypercube domain.
1.2 Previous work
The problem of testing unateness was first considered by Goldreich et al. [11]. In their work, by extending their monotonicity tester, they obtain a nonadaptive, -sided error tester for unateness with query complexity . Recently, Khot and Shinkar [12] gave an adaptive unateness tester with query complexity .
The related property of monotonicity has been studied extensively for different types of functions in the context of property testing. The problem of testing monotonicity of Boolean functions over the hypercube domain was first introduced by Goldreich et al. [11]. It was shown in [8, 11] that monotonicity for hypercube domain can be tested with query complexity . A monotonicity tester with better query complexity of was introduced by Chakrabarty and Seshadhri [5]. Chen et al. [6] modified the tester of Chakrabarty and Seshadhri [5] and improved the query complexity to . Most recently, Khot et al. [13] improved the query complexity of the tester to .
The lower bound for any nonadaptive one-sided error tester for monotonicity over the hypercube was proved to be by Fischer et al. [9]. Also, Chen et al. [7] gave a lower bound of almost for any nonadaptive, two-sided error tester. Moreover, there is a lower bound of over the real-valued functions by Blais et al. [3]. Most recently, Belovs and Blais [1] gave a lower bound of for adaptive testers of Boolean functions over the hypercube. Chakrabarty and Seshadhri [4] proved that any adaptive, two-sided monotonicity tester for functions must make queries.
2 Algorithm for Testing Unateness
In this section, we present an algorithm to test unateness of real-valued functions over the hypergrid domain and prove Theorem 2.1.
We use the notation to denote concatenation with respect to the locations in the set . More specifically, this operation fills the locations in with bits in , and the other locations with bits in , respectively.
Theorem 2.1.
For a given function , there exists a -sided error unateness tester with a query complexity of , where is the proximity parameter.
Proof.
The main idea of the tester described in Algorithm 1 is as follows. Given a function , the tester finds a subset of influential dimensions , such that the dependence of on the remaining dimensions, , is negligible. Furthermore, for each influential dimension , the tester finds an edge , where , and assigns a direction to the -th dimension according to the value of at these two points. The direction is up if and it is down if . After that, the algorithm applies a monotonicity tester on with respect to the directions for the dimensions in and some random assignments for other dimensions, and outputs the answer.
In order to find influential dimensions, the tester uses the function Find_an_Influential_Dimension, which is presented in Algorithm 2. It works as a subroutine and tries to find an influential dimension in each run. It gets oracle access to a function , and a subset of dimensions , which is empty at the beginning. This subroutine outputs if it doesn’t find any new influential dimension. Otherwise, it outputs a dimension and its direction .
This subroutine can find a new influential dimension and its direction with high probability if has non-negligible dependence on the dimensions in . Each time we run Find_an_Influential_Dimension, it picks two points uniformly and independently at random, whose coordinates are equal in the dimensions in . If , it uses binary search to decrease the distance between and to , while ensuring that still holds.
If the input function is unate, then the tester always accepts, as Algorithm 2 always finds the correct direction for each influential dimension and the function with respect to the influential dimensions is monotone.
In order to show the correctness of Algorithm 1, we will prove the following two lemmas. In these lemmas let denote the number of different values in the image of the function , and where and be the fraction of the frequent value among the values of .
Lemma 2.2.
Lemma 2.3.
Let be a real-valued function, and let such that,
(1) |
Then, for a random ,
Proof of Lemma 2.2.
First, we show that is equal to the probability that Algorithm 2 finds a new dimension on input . Algorithm 2 finds a new dimension if and only if in Line . By definition of , the probability of choosing such that is , and the probability of choosing such that is . The total probability of choosing two different values is for a fixed . So, the probability over all possible ’s is .
Now, we state the following claim to prove that when the Algorithm 2 finds a new dimension then the value of does not increase.
Claim 2.4.
For and , when the dimension is added to the set , the value of
does not increase.
Proof.
Let denote when . Let . Define , to be equal to for all dimensions in , and equal to in the dimension, for each . To simplify notation for the rest of the proof, let , , for . Then, . The probability that Algorithm 2 finds a new dimension on input is
To complete the proof, it is enough to show that , where . This inequality holds because and is concave. ∎
The following claim completes the proof of Lemma 2.2.
Claim 2.5.
After iterations of Algorithm 2, either the size of the set is equal to , or with probability at least , the following inequality holds,
Proof.
Let be an indicator random variable, which is equal to if Algorithm 2 finds a new dimension in the iteration and , otherwise. We have , where is the set of influential dimensions in the iteration. Hence, the total number of dimensions that Algorithm 2 finds after iterations is . Now, after iterations, if the following holds:
then,
Using Chernoff Bound we have,
For and , we have
∎
This completes the proof of Lemma 2.2. ∎
Proof of Lemma 2.3.
Define the plurality function as such that is the maximum (ties are broken arbitrarily).
By assumption (1) for a uniformly random , it holds that
Without loss of generality, assume that is the probability of the value with the highest frequency in . Hence,
Claim 2.6.
For all ,
Proof.
To simplify notations for the rest of the proof, let . We have
So it is enough to show that, or which can be proved as follows,
∎
The proof of Theorem 2.1 follows from Lemmas 2.2 and 2.3. Let be the set of influential dimensions in the unateness tester after iterations of Algorithm 2. By Lemma 2.2 the following inequality holds with probability at least
If satisfies the above inequality and is -far from being unate, then by Lemma 2.3, for a random , the function is -far from being unate with probability at least . And with the same probability it is -far from being monotone with respect to the directions of dimensions in the set . So, with high probability the monotonicity tester in Algorithm 1 will reject with respect to the directions of the dimensions in .
Now, we analyze the query complexity of Algorithm 1. Each call of Algorithm 2 makes queries to perform the binary search. Algorithm 2 is called times by Algorithm 1. At the end, Algorithm 1 runs monotonicity tester with query complexity . So, the total query complexity of Algorithm 1 is .
This completes the proof of Theorem 2.1. ∎
3 Lower Bounds for Unateness
3.1 Lower Bound for Real-Valued Functions
In this section, we prove an adaptive, 2-sided error lower bound for testing unateness of functions over the hypergrid domain. This lower bound technique builds on the one used for proving the lower bound for monotonicity by Blais et al. [3].
Theorem 3.1.
Testing for unateness requires queries.
Proof.
First, we consider the case when . We will prove the lower bound for testing unateness in this case by a reducton from Set-Disjointness problem.
Definition 3.1.
(Set-Disjointness) In the Set-Disjointness problem, there are two players Alice and Bob. Alice receives a string as input and Bob receives a string as input, where both strings have size . Alice and Bob also have access to a random string. They must compute the value of function , which is if and otherwise.
Theorem 3.2.
Testing for unateness requires queries.
Proof.
Let be the subsets received by Alice and Bob as the input to an instance of the Set-Disjointness problem. Alice and Bob build functions , respectively, where and . Let be a function defined by .
Claim 3.3.
The following holds:
-
(a)
The function is unate if and are disjoint.
-
(b)
The function is -far from unate, otherwise.
Proof.
Fix . For every , we define to be the vectors obtained by fixing the coordinate of to and , respectively.
Fist, we prove part . Since and are disjoint, there are three cases:
-
1.
and . Then,
-
2.
and . Then,
-
3.
and . Then,
So, when and are disjoint, the function is non-decreasing along dimension .
For the part of our claim, since there exists . For this , we will show that there exists -fraction of pairs of the form such that and another -fraction of pairs such that implying that is not unate. We have
It is clear that if then . And if then . Suppose that and also . Let be with the bit flipped. Then, , which means with probability . By the same argument, with probability . So, at least for of these pairs we have . By using the same technique we can prove that for at least fraction of these pairs we have . Therefore, when and are overlapping, is -far from unate. ∎
This completes the proof of Theorem 3.2 ∎
Now consider the case when . We can again use a reduction from set-disjointness problem.
Theorem 3.4.
Testing for unateness, where , requires queries.
Proof.
Without lost of generality we can also assume that . Let be the functions given to Alice and Bob in the communication game, where . Now we will define the function (as defined in [3]), as follows:
This function rounds up to for strings with low Hamming distance and rounds down to for strings with high Hamming distance. It also keeps the actual value of for points such that . By the definition of , this value will be between and .
Claim 3.5.
Function is unate if is unate and is -far from unate when is -far from unate.
Proof.
Since every monotone function is also unate, the first part of the claim directly follows from Blais et al. [3].
For the second part we prove that the distance between and is at most . Thus, when and intersect, is -far from unate and so is -far from unate. Let be a uniformly random point from . We know that when . By Chernoff Bound,
By triangle inequality, is at least -far from unate. ∎
This completes the proof of Theorem 3.4. ∎
For the last case, we prove the following theorem.
Theorem 3.6.
Testing a function for unateness, where , requires queries.
Proof.
In this case, we can prove the lower bound by using a reduction to Theorem 3.4. Let be the largest integer such that . We prove the following claim.
Claim 3.7.
For every function , there exists a function satisfying the following conditions:
-
1.
If is unate, then is also unate.
-
2.
If is -far from unate, then is also -far from unate.
-
3.
For all , we can find with one query to .
Proof.
We use padding technique to construct from . Let where and . The first and third conditions can be directly deduced from the definition of . For the second condition, suppose, for the sake of contradiction that is -close from unate. Then, there exists a unate function , such that . By an averaging argument, we can find a where, . Now, let for all . Thus, is unate and , contradicting the assumption that is -far from unate. ∎
Now we can construct a tester for a given input . Suppose, is the function that satisfies Claim 3.7. We run the unateness tester on and output its answer. By Claim 3.7, correctness of this tester follows from the correctness of the tester for . Since in Theorem 3.4 we proved that the unateness tester for uses queries and Claim 3.7 condition holds, the tester for uses the same number of queries. This means testing a function for unateness, where , requires queries. ∎
3.2 Lower Bound for Boolean Functions
In this section, we prove a nonadaptive, 1-sided error lower bound for testing unateness of Boolean functions over the hypercube domain. This lower bound technique is similar to the one used for proving the lower bound for monotonicity by Fischer et al. [9].
Theorem 3.8.
Every nonadaptive 1-sided error tester for unateness of functions of the form must make queries.
The proof of the theorem is by the application of Yao’s minimax principle. A 1-sided error tester must reject only if it finds a violation, otherwise it must accept. We define a distribution over a set of “hard” functions and prove that for this hard distribution, a tester with query complexity detects a violation with probability at most .
For , define as the number of bits that are equal to . The set of hard functions is defined as follows: for every , define as
Claim 3.9.
For every , is -far from unate for some constant such that .
Proof.
For a fixed , group together all points that differ only in the and coordinate. There are points in each group as illustrated in Figure 3.1. Overall, there are such independent groups.
It can be seen that a constant fraction of such groups violate unateness of (by its definition). In each such group, the value of on at least point has to be changed (or “repaired”) to make it unate. Thus, overall, a constant fraction of points have to be changed to make the function unate. Hence, is -far from unate for some constant .
∎
Proof of Theorem 3.8.
Let be the queried set of points from of size . By the definition of 1-sided error tester, we need to sample at least one violated, comparable pair of points to reject the function (A pair of points is comparable if either or ). So, the tester can detect a violated pair for if there exists two queries such that they are comparable and differ in either or coordinate. Construct an undirected graph with vertex set and edge set . Consider a spanning forest of this graph. If there exists a violation by function in pair they should be in the same tree. Moreover, there should exist an adjacent pair of vertices in the path between and which differ in the bit. Therefore, the total number of functions for which the query set could find the violation is at most the maximum number of edges in the spanning forest (which is at most ) times the maximum possible distance between two adjacent vertices (which is at most with respect to our function because all violations are for such that ). So at most functions can be detected for violation. We have different functions. Hence, the number of queries required is at least . ∎
4 Open Questions
Our bounds for testing unateness are nearly tight for real-valued functions. However, there is a gap between the upper and lower bounds for Boolean functions. The first open question is to close this gap. In this paper, we consider testing unateness of real-valued functions with respect to the Hamming distance. Can one design testers with respect to other metrics such as -distances, as defined in [2]?
References
- Belovs and Blais [2016] Aleksandrs Belovs and Eric Blais. A polynomial lower bound for testing monotonicity. In Proceedings of the 48th Annual ACM SIGACT Symposium on Theory of Computing, STOC 2016, Cambridge, MA, USA, June 18-21, 2016, pages 1021–1032, 2016.
- Berman et al. [2014] Piotr Berman, Sofya Raskhodnikova, and Grigory Yaroslavtsev. L-testing. In Symposium on Theory of Computing, STOC 2014, New York, NY, USA, May 31 - June 03, 2014, pages 164–173, 2014.
- Blais et al. [2012] Eric Blais, Joshua Brody, and Kevin Matulef. Property testing lower bounds via communication complexity. Computational Complexity, 21(2):311–358, 2012.
- Chakrabarty and Seshadhri [2013a] Deeparnab Chakrabarty and C Seshadhri. Optimal bounds for monotonicity and lipschitz testing over hypercubes and hypergrids. In Proceedings of the forty-fifth annual ACM symposium on Theory of computing, pages 419–428. ACM, 2013a.
- Chakrabarty and Seshadhri [2013b] Deeparnab Chakrabarty and C. Seshadhri. A monotonicity tester for boolean functions over the hypercube. In Symposium on Theory of Computing Conference, STOC’13, Palo Alto, CA, USA, June 1-4, 2013, pages 411–418, 2013b.
- Chen et al. [2014] Xi Chen, Rocco A. Servedio, and Li-Yang Tan. New algorithms and lower bounds for monotonicity testing. In 55th IEEE Annual Symposium on Foundations of Computer Science, FOCS 2014, Philadelphia, PA, USA, October 18-21, 2014, pages 286–295, 2014.
- Chen et al. [2015] Xi Chen, Anindya De, Rocco A. Servedio, and Li-Yang Tan. Boolean function monotonicity testing requires (almost) non-adaptive queries. In Proceedings of the Forty-Seventh Annual ACM on Symposium on Theory of Computing, STOC 2015, Portland, OR, USA, June 14-17, 2015, pages 519–528, 2015.
- Dodis et al. [1999] Yevgeniy Dodis, Oded Goldreich, Eric Lehman, Sofya Raskhodnikova, Dana Ron, and Alex Samorodnitsky. Improved testing algorithms for monotonicity. In Randomization, Approximation, and Combinatorial Algorithms and Techniques, Third International Workshop on Randomization and Approximation Techniques in Computer Science, and Second International Workshop on Approximation Algorithms for Combinatorial Optimization Problems RANDOM-APPROX’99, Berkeley, CA, USA, August 8-11, 1999, Proceedings, pages 97–108, 1999.
- Fischer et al. [2002] Eldar Fischer, Eric Lehman, Ilan Newman, Sofya Raskhodnikova, Ronitt Rubinfeld, and Alex Samorodnitsky. Monotonicity testing over general poset domains. In Proceedings on 34th Annual ACM Symposium on Theory of Computing, May 19-21, 2002, Montréal, Québec, Canada, pages 474–483, 2002.
- Goldreich et al. [1996] Oded Goldreich, Shafi Goldwasser, and Dana Ron. Property testing and its connection to learning and approximation. Electronic Colloquium on Computational Complexity (ECCC), 3(57), 1996.
- Goldreich et al. [2000] Oded Goldreich, Shafi Goldwasser, Eric Lehman, Dana Ron, and Alex Samorodnitsky. Testing monotonicity. Combinatorica, 20(3):301–337, 2000.
- Khot and Shinkar [2016] Subhash Khot and Igor Shinkar. An queries adaptive tester for unateness. RANDOM, 2016.
- Khot et al. [2015] Subhash Khot, Dor Minzer, and Muli Safra. On monotonicity testing and boolean isoperimetric type theorems. In IEEE 56th Annual Symposium on Foundations of Computer Science, FOCS 2015, Berkeley, CA, USA, 17-20 October, 2015, pages 52–58, 2015.
- Kuo and Chou [1986] Yue-Sun Kuo and WK Chou. Generating essential primes for a boolean function with multiple-valued inputs. In Proceedings of the 23rd ACM/IEEE Design Automation Conference, pages 193–199. IEEE Press, 1986.
- Mishchenko [2014] Alan Mishchenko. Introduction to zero-suppressed decision diagrams. Applications of Zero-Suppressed Decision Diagrams, 2014.
- Rubinfeld and Sudan [1996] Ronitt Rubinfeld and Madhu Sudan. Robust characterizations of polynomials with applications to program testing. SIAM J. Comput., 25(2):252–271, 1996.
- Sasao [2012] Tsutomu Sasao. Switching theory for logic synthesis. Springer Science & Business Media, 2012.